using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {

            //Micheal
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Micheal De Santa", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "ssshh he is really called Micheal Townley shhh", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("m.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("skin layer.png");
                        var flesh = ModAPI.LoadTexture("flesh layer.png");
                        var bone = ModAPI.LoadTexture("bone layer.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
                }
            );

            //Franklin
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Franklin Clinton", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Killed both of his friends.", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("F.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("skin layefr.png");
                        var flesh = ModAPI.LoadTexture("flesh layer Copy.png");
                        var bone = ModAPI.LoadTexture("bone layer Copy.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
                }
            );

            //Trevor
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Trevor Philips", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Smells alot of gasoline.", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("T.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("skin layetr.png");
                        var flesh = ModAPI.LoadTexture("flesh layer Copy (2).png");
                        var bone = ModAPI.LoadTexture("bone layer Copy (2).png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
                }
            );

            //Niko
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Niko Bellic", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "*phone rings* Niko! Lets go bowling.", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("N.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("skin layNer.png");
                        var flesh = ModAPI.LoadTexture("flesh layer Copy (3).png");
                        var bone = ModAPI.LoadTexture("bone layer Copy (3).png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
                }
            );

            //Tommy
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Tommy Vercetti", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "You took fifteen years from me, Sonny, and now I'm gonna make you pay!", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("TV.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("skin layeTVr.png");
                        var flesh = ModAPI.LoadTexture("flesh layer Copy (5).png");
                        var bone = ModAPI.LoadTexture("bone layer Copy (5).png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
                }
            );

            //Claude
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Claude Speed", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Claudes Iconic Line: ...", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("CS.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("skin layeCLr.png");
                        var flesh = ModAPI.LoadTexture("flesh layer Copy (6).png");
                        var bone = ModAPI.LoadTexture("bone layer Copy (6).png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
                }
            );

            //CJ
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = "Carl Johnson", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "ALL YOU HAD TO DO WAS FOLLOW THE DAMN TRAIN CJ!", //new item description
                    CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("CJ.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer (see Human textures folder in this repository)
                        var skin = ModAPI.LoadTexture("skin layCjer.png");
                        var flesh = ModAPI.LoadTexture("flesh layer Copy (4).png");
                        var bone = ModAPI.LoadTexture("bone layer Copy (4).png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows: 
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        person.SetBodyTextures(skin, flesh, bone, 1);

                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );

            //Big Smoke
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = "Big Smoke", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "ill have two number 9s, a number 9 large, a number 6 with extra dip, a number 7, two number 45s, one with cheese, and a large soda.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("bigp.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer (see Human textures folder in this repository)
                        var skin = ModAPI.LoadTexture("big.png");
                        var flesh = ModAPI.LoadTexture("flesh layer - Copy - Copy.png");
                        var bone = ModAPI.LoadTexture("bone layer - Copy - Copy.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows: 
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        person.SetBodyTextures(skin, flesh, bone, 1);

                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );

            //Roman
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = "Roman", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "The Bowling Master!", //new item description
                    CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("romanp.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer (see Human textures folder in this repository)
                        var skin = ModAPI.LoadTexture("roman.png");
                        var flesh = ModAPI.LoadTexture("flesh layer Copy (7).png");
                        var bone = ModAPI.LoadTexture("bone layer Copy (7).png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows: 
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        person.SetBodyTextures(skin, flesh, bone, 1);

                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );

            //Ryder
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = "Ryder", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "You looking too skinny CJ.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("rydp.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer (see Human textures folder in this repository)
                        var skin = ModAPI.LoadTexture("ryd.png");
                        var flesh = ModAPI.LoadTexture("flesh layer Copy (8).png");
                        var bone = ModAPI.LoadTexture("bone layer Copy (8).png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows: 
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        person.SetBodyTextures(skin, flesh, bone, 1);

                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );

            //Sweet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = "Sweet", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "You gotta love your hood like you love your homies. Its always been that way, and aint nothing ever gonna change, I done seen it all.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("sweetp.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer (see Human textures folder in this repository)
                        var skin = ModAPI.LoadTexture("sweet.png");
                        var flesh = ModAPI.LoadTexture("flesh layer Copy (9).png");
                        var bone = ModAPI.LoadTexture("bone layer Copy (9).png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows: 
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        person.SetBodyTextures(skin, flesh, bone, 1);

                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );

            //Johnny
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = "Johnny Klebitz", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "Is now just a little peice of brain on trevors shoe", //new item description
                    CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("f.jpg"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer (see Human textures folder in this repository)
                        var skin = ModAPI.LoadTexture("john.png");
                        var flesh = ModAPI.LoadTexture("flesh layer - Copy - Copy.png");
                        var bone = ModAPI.LoadTexture("bone layer - Copy - Copy.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows: 
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        person.SetBodyTextures(skin, flesh, bone, 1);

                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );

            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Knife"), //item to derive from
        NameOverride = "Chop", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Very sharp teeth.", //new item description
        CategoryOverride = ModAPI.FindCategory("Melee"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("shop.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //get the SpriteRenderer and replace its sprite with a custom one
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("shop.png");
        }
    }
);

            //LESTER
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = "Lester Crest", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "how do i make lester look good in ppg", //new item description
                    CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("daf.jpg"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        //load textures for each layer (see Human textures folder in this repository)
                        var skin = ModAPI.LoadTexture("crester.png");
                        var flesh = ModAPI.LoadTexture("flesh layer - Copy - Copy.png");
                        var bone = ModAPI.LoadTexture("bone layer - Copy - Copy.png");

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        //use the helper function to set each texture
                        //parameters are as follows: 
                        //  skin texture, flesh texture, bone texture, sprite scale
                        //you can pass "null" to fall back to the original texture
                        person.SetBodyTextures(skin, flesh, bone, 1);

                        //change procedural damage colours if they interfere with your texture (rgb 0-255)
                        person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                        person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                        person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                        person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                    }
                }
            );
        }
    }
}